---
product: "AG Grid"
title: "Find"
description: "Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find ( + ) within the browser."
enterprise: true
framework: javascript
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/view-refresh/"
    - title: "Reference Data"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/reference-data/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Find

Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find (`^ Ctrl` + `F`) within the browser.

> **Note**
>
> Find is only compatible with the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-models/).

## Enabling Find

### Using Quick Access Toolbar

The recommended way to display the Find input is as a [Quick Access Toolbar](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/toolbar/) item. This keeps the Find UI integrated with the grid and requires no additional markup.

#### Find with Toolbar

```ts
import {
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ],
  toolbar: {
    items: ["agFindToolbarItem"],
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Find with Toolbar](https://www.ag-grid.com/archive/36.2.0/examples/find/find-toolbar/typescript/)

The configuration used in the example above is:

```js
const gridOptions = {
    toolbar: {
        items: ['agFindToolbarItem'],
    },

    // other grid options ...
}
```

### Using Grid Options

Find can also be enabled directly via the grid option `findSearchValue`, passing the text to search for.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findSearchValue` | `string` |  |  |  |

```js
const gridOptions = {
    findSearchValue: 'rowing',

    // other grid options ...
}
```

The grid API methods `findNext()`, `findPrevious()`, and `findGoTo(matchNumber)` can be used to move between the matches, or `findClearActive()` can be used to clear the active match.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findNext` | `Function` |  |  |  |
| `findPrevious` | `Function` |  |  |  |
| `findGoTo` | `Function` |  |  |  |
| `findClearActive` | `Function` |  |  |  |

Changing the Find search value, changing the active match, or updates to the grid that cause changes to the visible cells (e.g. changing columns/rows) trigger the `findChanged` event. The event contains details on the active match, as well as the total number of matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findChanged` | `FindChangedEvent` |  |  |  |

The active match and the total number of matches can also be retrieved via the API.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetTotalMatches` | `Function` |  |  |  |
| `findGetActiveMatch` | `Function` |  |  |  |

#### Find

```ts
import {
  ClientSideRowModelModule,
  FindChangedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule } from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([FindModule, ClientSideRowModelModule]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ],
  onFindChanged: (event: FindChangedEvent) => {
    const { activeMatch, totalMatches, findSearchValue } = event;
    (document.getElementById("activeMatchNum") as HTMLElement).textContent =
      findSearchValue?.length
        ? `${activeMatch?.numOverall ?? 0}/${totalMatches}`
        : "";
    console.log("findChanged", event);
  },
};

function next() {
  gridApi!.findNext();
}

function previous() {
  gridApi!.findPrevious();
}

function goToFind() {
  const num = Number(
    (document.getElementById("find-goto") as HTMLInputElement).value,
  );
  if (isNaN(num) || num < 0) {
    return;
  }
  gridApi!.findGoTo(num);
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

const findInput = document.getElementById("find-text-box") as HTMLInputElement;
findInput.addEventListener("input", (event) => {
  gridApi.setGridOption(
    "findSearchValue",
    (event.target as HTMLInputElement).value,
  );
});
findInput.addEventListener("keydown", (event) => {
  if (event.key === "Enter") {
    event.preventDefault();
    const backwards = event.shiftKey;
    if (backwards) {
      previous();
    } else {
      next();
    }
  }
});

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).next = next;
  (<any>window).previous = previous;
  (<any>window).goToFind = goToFind;
}
```

[Live example: Find](https://www.ag-grid.com/archive/36.2.0/examples/find/find/typescript/)

The Find input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/input-fields/).

## Using Find with Cell Components

By default, Find searches within the [Formatted Value](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/value-formatters/) of the cell, or the raw cell value if there is no Value Formatter. This is what is displayed in the cell by default.

[Cell Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/component-cell-renderer/) may display text that does not appear in the cell value. To enable Find to search within this additional text, the `getFindText` callback can be implemented on the Column Definition. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'year',
            getFindText: params => `Year is ${params.value}`,
        }
    ],

    // other grid options ...
}
```

When providing a custom cell component, the component is responsible for highlighting any matches and active matches within the cell. The grid API provides the following methods to help with this.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetNumMatches` | `Function` |  |  |  |
| `findGetParts` | `Function` |  |  |  |

The following example demonstrates a custom cell component in the `Year` column that implements match highlighting using the methods above. The find input is provided by the toolbar. The custom cell component reuses the grid CSS classes `ag-find-match` and `ag-find-active-match` to apply the same styling as the default grid cell component.

#### Find with Cell Components

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GetFindTextParams,
  GridApi,
  GridOptions,
  ModuleRegistry,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { FindRenderer } from "./findRenderer";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    {
      field: "year",
      cellRenderer: FindRenderer,
      getFindText: (params: GetFindTextParams) => {
        const cellValue =
          params.getValueFormatted() ?? params.value?.toString();
        if (!cellValue?.length) {
          return null;
        }
        return `Year is ${cellValue}`;
      },
    },
  ],
  findSearchValue: "e",
  toolbar: {
    items: ["agFindToolbarItem"],
  },
  onFirstDataRendered: (event: FirstDataRenderedEvent) => {
    event.api.findNext();
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/examples/find/find-cell-components/typescript/)

> **Note**
>
> Find does not work with the [Animate Show Changed Cell Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/change-cell-renderers/#animate-show-changed-cells) or the [Animate Slide Cell Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/change-cell-renderers/#animate-slide-cells). If using these, provide a `getFindText` that returns `null` to exclude them from the search results. The same approach should also be used if manually specifying `agCheckboxCellRenderer`.

## Customising Find

Find can be customised by providing an object of type `FindOptions` to the grid option `findOptions`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `currentPageOnly` | `boolean` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `searchDetail` | `boolean` |  |  |  |

```js
const gridOptions = {
    findOptions: {
        caseSensitive: true,
        currentPageOnly: true,
    },

    // other grid options ...
}
```

The following example demonstrates performing a case sensitive search, and finding matches within the current page only:

#### Customising Find

```ts
import {
  ClientSideRowModelModule,
  FindChangedEvent,
  GridApi,
  GridOptions,
  ModuleRegistry,
  PaginationModule,
  PinnedRowModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  PaginationModule,
]);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  pinnedTopRowData: [{ athlete: "Top" }],
  pinnedBottomRowData: [{ athlete: "Bottom" }],
  columnDefs: [
    { field: "athlete" },
    { field: "country" },
    { field: "sport", rowGroup: true, hide: true },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ],
  defaultColDef: {
    enableRowGroup: true,
  },
  pagination: true,
  paginationPageSize: 5,
  paginationPageSizeSelector: [5, 10],
  toolbar: {
    items: ["agRowGroupPanelToolbarItem", "agFindToolbarItem"],
  },
  findOptions: {
    caseSensitive: true,
    currentPageOnly: true,
  },
  onFindChanged: (event: FindChangedEvent) => {
    const { activeMatch } = event;
    (document.getElementById("activeMatch") as HTMLElement).textContent =
      activeMatch
        ? `Active match: { pinned: ${activeMatch.node.rowPinned}, row index: ${activeMatch.node.rowIndex}, column: ${activeMatch.column?.getColId()}, match number in cell: ${activeMatch.numInMatch} }`
        : "";
  },
};

function goToFind() {
  const num = Number(
    (document.getElementById("find-goto") as HTMLInputElement).value,
  );
  if (isNaN(num) || num < 0) {
    return;
  }
  gridApi!.findGoTo(num);
}

function toggleCaseSensitive() {
  const caseSensitive = (
    document.getElementById("caseSensitive") as HTMLInputElement
  ).checked;
  const findOptions = gridApi.getGridOption("findOptions");
  gridApi.setGridOption("findOptions", {
    ...findOptions,
    caseSensitive,
  });
}

function toggleCurrentPageOnly() {
  const currentPageOnly = (
    document.getElementById("currentPageOnly") as HTMLInputElement
  ).checked;
  const findOptions = gridApi.getGridOption("findOptions");
  gridApi.setGridOption("findOptions", {
    ...findOptions,
    currentPageOnly,
  });
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
  .then((response) => response.json())
  .then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).goToFind = goToFind;
  (<any>window).toggleCaseSensitive = toggleCaseSensitive;
  (<any>window).toggleCurrentPageOnly = toggleCurrentPageOnly;
}
```

[Live example: Customising Find](https://www.ag-grid.com/archive/36.2.0/examples/find/customising-find/typescript/)

## Find with Master / Detail

When using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/master-detail/), Find will not search within detail rows by default (either [Detail Grids](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/master-detail-grids/) or [Custom Details](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/master-detail-custom-detail/)). To enable Find to search within detail rows, set `searchDetail` within `findOptions` to `true`:

```js
const gridOptions = {
    findOptions: {
        searchDetail: true,
    },

    // other grid options ...
}
```

### Detail Grids

If a row containing a Detail Grid is expanded, Find will automatically search within the Detail Grid. If the master row is not expanded, the grid does not exist yet, so Find does not know how many matches there are. Find cannot create all of the Detail Grids as there may be a very large number of them.

If you want Find to search within collapsed detail rows, then you must provide the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Detail Grid. If the active match moves to within the Detail Grid, the Detail Grid will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The following example demonstrates Find across nested Master / Detail Grids:

#### Find with Detail Grids

```ts
import {
  ClientSideRowModelModule,
  FirstDataRenderedEvent,
  GetDetailRowDataParams,
  GetFindMatchesParams,
  GetRowIdParams,
  GridOptions,
  IDetailCellRendererParams,
  ModuleRegistry,
  RowApiModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

const gridOptions: GridOptions = {
  rowData: getData(),
  columnDefs: [
    { field: "a1", cellRenderer: "agGroupCellRenderer" },
    { field: "b1" },
  ],
  defaultColDef: {
    flex: 1,
  },
  masterDetail: true,
  getRowId: (params: GetRowIdParams) => params.data.a1,
  toolbar: {
    items: ["agFindToolbarItem"],
  },
  findOptions: {
    searchDetail: true,
  },
  detailCellRendererParams: {
    // level 2 grid options
    detailGridOptions: {
      columnDefs: [
        { field: "a2", cellRenderer: "agGroupCellRenderer" },
        { field: "b2" },
      ],
      defaultColDef: {
        flex: 1,
      },
      masterDetail: true,
      detailRowHeight: 240,
      getRowId: (params: GetRowIdParams) => params.data.a2,
      findOptions: {
        searchDetail: true,
      },
      detailCellRendererParams: {
        // level 3 grid options
        detailGridOptions: {
          columnDefs: [
            { field: "a3", cellRenderer: "agGroupCellRenderer" },
            { field: "b3" },
          ],
          defaultColDef: {
            flex: 1,
          },
          getRowId: (params: GetRowIdParams) => params.data.a3,
        },
        getDetailRowData: (params: GetDetailRowDataParams) => {
          params.successCallback(params.data.children);
        },
        getFindMatches,
      } as IDetailCellRendererParams,
    },
    getDetailRowData: (params: GetDetailRowDataParams) => {
      params.successCallback(params.data.children);
    },
    getFindMatches,
  } as IDetailCellRendererParams,
  onFirstDataRendered: (event: FirstDataRenderedEvent) => {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  },
};

function getFindMatches(params: GetFindMatchesParams) {
  const getMatchesForValue = params.getMatchesForValue;
  let numMatches = 0;
  const checkRow = (row: any) => {
    for (const key of Object.keys(row)) {
      if (key === "children") {
        row.children.forEach((child: any) => checkRow(child));
      } else {
        numMatches += getMatchesForValue(row[key]);
      }
    }
  };
  params.data.children.forEach(checkRow);
  return numMatches;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
createGrid(gridDiv, gridOptions);
```

[Live example: Find with Detail Grids](https://www.ag-grid.com/archive/36.2.0/examples/find/find-detail-grid/typescript/)

### Custom Detail

For Find to work with Custom Detail Cells, Find needs to know how many matches are within the detail row. This is done by providing the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Custom Detail. If the active match moves to within the Custom Detail, the Custom Detail will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Custom Detail Cell Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find across Custom Details:

#### Find with Custom Details

```ts
import {
  ClientSideRowModelModule,
  FindDetailCellRendererParams,
  FirstDataRenderedEvent,
  GetFindMatchesParams,
  GridOptions,
  ModuleRegistry,
  RowApiModule,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { DetailCellRenderer } from "./detailCellRenderer";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

const gridOptions: GridOptions = {
  columnDefs: [
    // group cell renderer needed for expand / collapse icons
    { field: "name", cellRenderer: "agGroupCellRenderer" },
    { field: "account" },
    { field: "calls" },
  ],
  masterDetail: true,
  detailCellRenderer: DetailCellRenderer,
  detailCellRendererParams: {
    getFindMatches: (params: GetFindMatchesParams) => {
      return params.getMatchesForValue("My Custom Detail");
    },
  } as FindDetailCellRendererParams,
  detailRowHeight: 100,
  toolbar: {
    items: ["agFindToolbarItem"],
  },
  findOptions: {
    searchDetail: true,
  },
  onFirstDataRendered: (event: FirstDataRenderedEvent) => {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  },
};

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
const gridApi = createGrid(gridDiv, gridOptions);

fetch("https://www.ag-grid.com/example-assets/master-detail-data.json")
  .then((response) => response.json())
  .then((data: IAccount[]) => gridApi!.setGridOption("rowData", data));
```

[Live example: Find with Custom Details](https://www.ag-grid.com/archive/36.2.0/examples/find/find-custom-detail/typescript/)

## Find with Full Width Rows

For Find to work with [Full Width Rows](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/full-width-rows/), Find needs to know how many matches are within the row. This is done by providing the `getFindMatches` callback to the `fullWidthCellRendererParams` grid option. This tells Find how many matches are expected to be in the Full Width Row.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Full Width Row Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find with Full Width Rows:

#### Find with Full Width Rows

```ts
import {
  ClientSideRowModelModule,
  FindFullWidthCellRendererParams,
  GetFindMatchesParams,
  GridOptions,
  IsFullWidthRowParams,
  ModuleRegistry,
  RowHeightParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { getData, getLatinText } from "./data";
import { FullWidthCellRenderer } from "./fullWidthCellRenderer";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

const gridOptions: GridOptions = {
  columnDefs: [
    { field: "name" },
    { field: "continent" },
    { field: "language" },
  ],
  defaultColDef: {
    flex: 1,
  },
  rowData: getData(),
  getRowHeight: (params: RowHeightParams) => {
    // return 100px height for full width rows
    if (isFullWidth(params.data)) {
      return 100;
    }
  },
  isFullWidthRow: (params: IsFullWidthRowParams) => {
    return isFullWidth(params.rowNode.data);
  },
  fullWidthCellRenderer: FullWidthCellRenderer,
  fullWidthCellRendererParams: {
    getFindMatches: (params: GetFindMatchesParams) => {
      const getMatchesForValue = params.getMatchesForValue;
      // this example only implements searching across part of the renderer
      let numMatches = getMatchesForValue("Sample Text in a Paragraph");
      getLatinText().forEach((paragraph) => {
        numMatches += getMatchesForValue(paragraph);
      });
      return numMatches;
    },
  } as FindFullWidthCellRendererParams,
  toolbar: {
    items: ["agFindToolbarItem"],
  },
};

function isFullWidth(data: any) {
  // return true when country is Peru, France or Italy
  return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
createGrid(gridDiv, gridOptions);
```

[Live example: Find with Full Width Rows](https://www.ag-grid.com/archive/36.2.0/examples/find/find-full-width/typescript/)

## Find with Custom Group Row Component

Using Find with a [Custom Group Row Inner Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-group-rows/#custom-inner-renderer) (`groupRowRendererParams.innerRenderer`) or a [Custom Group Row Component](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-group-rows/#custom-cell-renderer) (`groupRowRenderer`) is similar to using [Using Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/#using-find-with-cell-components). If the component displays text that does not appear in the cell value, the `getFindText` callback can be implemented on the `groupRowRendererParams` grid option. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```js
const gridOptions = {
    groupRowRendererParams: {
        getFindText: params => `Group value is ${params.value}`,
    },

    // other grid options ...
}
```

## Content to Search

Find is designed to search within "visible" cell contents.

Searching is not performed within hidden columns. Columns not displayed due to [Column Groups](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/column-groups/) being expanded/collapsed are counted as being hidden.

The rows are searched after filtering and sorting have been performed.

Searching will be performed within the children of [Collapsed Row Groups](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/grouping-opening-groups/). When the active match is set to a child row within a collapsed group, the group is expanded (along with its parents if necessary).

When using [Row Pagination](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/row-pagination/), searching will be performed across all pages by default.

See the [Customising Find](https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/#customising-find) section for an example of using Find with Row Grouping, as well as how to customise behaviour for Pagination.

If data is mutated outside of the grid (e.g. not via grid options or API methods), Find will not re-run automatically. This would apply to situations where `api.refreshCells()` or `api.redrawRows()` are being used. To get Find to update, `api.findRefresh()` should be called after either of these API methods.


---
product: "AG Grid"
title: "Find"
description: "Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find ( + ) within the browser."
enterprise: true
framework: vue
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/view-refresh/"
    - title: "Reference Data"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/reference-data/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Find

Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find (`^ Ctrl` + `F`) within the browser.

> **Note**
>
> Find is only compatible with the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-models/).

## Enabling Find

### Using Quick Access Toolbar

The recommended way to display the Find input is as a [Quick Access Toolbar](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/toolbar/) item. This keeps the Find UI integrated with the grid and requires no additional markup.

#### Find with Toolbar

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"
        :toolbar="toolbar"></ag-grid-vue>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data() {
    return {
      toolbar: {
        items: ["agFindToolbarItem"],
      },
    };
  },
  methods: {
    onGridReady(params: GridReadyEvent) {
      this.gridApi = params.api;

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => {
          this.rowData = data;
        });
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "age", minWidth: 100 },
      { field: "gold", minWidth: 100 },
      { field: "silver", minWidth: 100 },
      { field: "bronze", minWidth: 100 },
    ]);
    const rowData = ref<any[]>(null);

    return {
      columnDefs,
      rowData,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find with Toolbar](https://www.ag-grid.com/archive/36.2.0/examples/find/find-toolbar/vue3/)

The configuration used in the example above is:

```ts
<ag-grid-vue
    :toolbar="toolbar"
    /* other grid options ... */>
</ag-grid-vue>

this.toolbar = {
    items: ['agFindToolbarItem'],
};
```

### Using Grid Options

Find can also be enabled directly via the grid option `findSearchValue`, passing the text to search for.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findSearchValue` | `string` |  |  |  |

```ts
<ag-grid-vue
    :findSearchValue="findSearchValue"
    /* other grid options ... */>
</ag-grid-vue>

this.findSearchValue = 'rowing';
```

The grid API methods `findNext()`, `findPrevious()`, and `findGoTo(matchNumber)` can be used to move between the matches, or `findClearActive()` can be used to clear the active match.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findNext` | `Function` |  |  |  |
| `findPrevious` | `Function` |  |  |  |
| `findGoTo` | `Function` |  |  |  |
| `findClearActive` | `Function` |  |  |  |

Changing the Find search value, changing the active match, or updates to the grid that cause changes to the visible cells (e.g. changing columns/rows) trigger the `findChanged` event. The event contains details on the active match, as well as the total number of matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findChanged` | `FindChangedEvent` |  |  |  |

The active match and the total number of matches can also be retrieved via the API.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetTotalMatches` | `Function` |  |  |  |
| `findGetActiveMatch` | `Function` |  |  |  |

#### Find

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  FindChangedEvent,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([FindModule, ClientSideRowModelModule]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <div class="example-wrapper">
        <div class="example-header">
            <div class="example-controls">
                <span>Find:</span>
                <input type="text" @input="onInput" @keydown="onKeyDown" />
                <button @click="previous()">Previous</button>
                <button @click="next()">Next</button>
                <span>{{activeMatchNum}}</span>
            </div>
            <div class="example-controls">
                <span>Go to match:</span>
                <input type="number" min="1" v-model="goTo" />
                <button @click="goToFind()">Go To</button>
            </div>
        </div>
        <ag-grid-vue
            style="width: 100%; height: 100%;"
            @grid-ready="onGridReady"
            :columnDefs="columnDefs"
            :rowData="rowData"
            :findSearchValue="findSearchValue"
            @find-changed="onFindChanged"></ag-grid-vue>
    </div>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data() {
    return {
      goTo: undefined,
      gridApi: undefined,
      activeMatchNum: undefined,
      findSearchValue: undefined,
    };
  },
  methods: {
    onFindChanged(event: FindChangedEvent) {
      const { activeMatch, totalMatches, findSearchValue } = event;
      this.activeMatchNum = findSearchValue?.length
        ? `${activeMatch?.numOverall ?? 0}/${totalMatches}`
        : "";
      console.log("findChanged", event);
    },
    next() {
      this.gridApi.findNext();
    },
    previous() {
      this.gridApi.findPrevious();
    },
    goToFind() {
      const num = Number(this.goTo);
      if (isNaN(num) || num < 0) {
        return;
      }
      this.gridApi.findGoTo(num);
    },
    onInput(event: Event) {
      this.findSearchValue = (event.target as HTMLInputElement).value;
    },
    onKeyDown(event: KeyboardEvent) {
      if (event.key === "Enter") {
        event.preventDefault();
        const backwards = event.shiftKey;
        if (backwards) {
          this.previous();
        } else {
          this.next();
        }
      }
    },
    onGridReady(params: GridReadyEvent) {
      this.gridApi = params.api;

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => {
          this.rowData = data;
        });
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "sport" },
      { field: "year" },
      { field: "age", minWidth: 100 },
      { field: "gold", minWidth: 100 },
      { field: "silver", minWidth: 100 },
      { field: "bronze", minWidth: 100 },
    ]);
    const rowData = ref<any[]>(null);

    return {
      columnDefs,
      rowData,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find](https://www.ag-grid.com/archive/36.2.0/examples/find/find/vue3/)

The Find input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/input-fields/).

## Using Find with Cell Components

By default, Find searches within the [Formatted Value](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/value-formatters/) of the cell, or the raw cell value if there is no Value Formatter. This is what is displayed in the cell by default.

[Cell Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/component-cell-renderer/) may display text that does not appear in the cell value. To enable Find to search within this additional text, the `getFindText` callback can be implemented on the Column Definition. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'year',
        getFindText: params => `Year is ${params.value}`,
    }
];
```

When providing a custom cell component, the component is responsible for highlighting any matches and active matches within the cell. The grid API provides the following methods to help with this.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetNumMatches` | `Function` |  |  |  |
| `findGetParts` | `Function` |  |  |  |

The following example demonstrates a custom cell component in the `Year` column that implements match highlighting using the methods above. The find input is provided by the toolbar. The custom cell component reuses the grid CSS classes `ag-find-match` and `ag-find-active-match` to apply the same styling as the default grid cell component.

#### Find with Cell Components

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  FirstDataRenderedEvent,
  GetFindTextParams,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import FindRenderer from "./findRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"
        :findSearchValue="findSearchValue"
        :toolbar="toolbar"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    FindRenderer,
  },
  data() {
    return {
      findSearchValue: "e",
      toolbar: {
        items: ["agFindToolbarItem"],
      },
    };
  },
  methods: {
    onFirstDataRendered(event: FirstDataRenderedEvent) {
      event.api.findNext();
    },
    onGridReady(params: GridReadyEvent) {
      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => {
          this.rowData = data;
        });
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      {
        field: "year",
        cellRenderer: "FindRenderer",
        getFindText: (params: GetFindTextParams) => {
          const cellValue =
            params.getValueFormatted() ?? params.value?.toString();
          if (!cellValue?.length) {
            return null;
          }
          return `Year is ${cellValue}`;
        },
      },
    ]);
    const rowData = ref<any[]>(null);

    return {
      columnDefs,
      rowData,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/examples/find/find-cell-components/vue3/)

> **Note**
>
> Find does not work with the [Animate Show Changed Cell Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/change-cell-renderers/#animate-show-changed-cells) or the [Animate Slide Cell Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/change-cell-renderers/#animate-slide-cells). If using these, provide a `getFindText` that returns `null` to exclude them from the search results. The same approach should also be used if manually specifying `agCheckboxCellRenderer`.

## Customising Find

Find can be customised by providing an object of type `FindOptions` to the grid option `findOptions`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `currentPageOnly` | `boolean` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `searchDetail` | `boolean` |  |  |  |

```ts
<ag-grid-vue
    :findOptions="findOptions"
    /* other grid options ... */>
</ag-grid-vue>

this.findOptions = {
    caseSensitive: true,
    currentPageOnly: true,
};
```

The following example demonstrates performing a case sensitive search, and finding matches within the current page only:

#### Customising Find

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  FindChangedEvent,
  GridReadyEvent,
  ModuleRegistry,
  PaginationModule,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  PaginationModule,
]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <div class="example-wrapper">
        <div class="example-header">
            <div class="example-controls">
                <label>
                    <span>caseSensitive:</span>
                    <input type="checkbox" @change="toggleCaseSensitive" checked>
                </label>
                <label>
                    <span>currentPageOnly:</span>
                    <input type="checkbox" @change="toggleCurrentPageOnly" checked>
                </label>
            </div>
            <div class="example-controls">
                <span>Go to match:</span>
                <input type="number" min="1" v-model="goTo" />
                <button @click="goToFind()">Go To</button>
            </div>
            <div>{{ activeMatch }}</div>
        </div>
        <ag-grid-vue
            style="width: 100%; height: 100%;"
            @grid-ready="onGridReady"
            :pinnedTopRowData="pinnedTopRowData"
            :pinnedBottomRowData="pinnedBottomRowData"
            :columnDefs="columnDefs"
            :defaultColDef="defaultColDef"
            :pagination="true"
            :paginationPageSize="paginationPageSize"
            :paginationPageSizeSelector="paginationPageSizeSelector"
            :toolbar="toolbar"
            :findOptions="findOptions"
            :rowData="rowData"
            @find-changed="onFindChanged"></ag-grid-vue>
    </div>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data() {
    return {
      goTo: undefined,
      gridApi: undefined,
      activeMatch: undefined,
      toolbar: {
        items: ["agRowGroupPanelToolbarItem", "agFindToolbarItem"],
      },
      findOptions: {
        caseSensitive: true,
        currentPageOnly: true,
      },
    };
  },
  methods: {
    onFindChanged(event: FindChangedEvent) {
      const { activeMatch } = event;
      this.activeMatch = activeMatch
        ? `Active match: { pinned: ${activeMatch.node.rowPinned}, row index: ${activeMatch.node.rowIndex}, column: ${activeMatch.column?.getColId()}, match number in cell: ${activeMatch.numInMatch} }`
        : "";
    },
    goToFind() {
      const num = Number(this.goTo);
      if (isNaN(num) || num < 0) {
        return;
      }
      this.gridApi.findGoTo(num);
    },
    onGridReady(params: GridReadyEvent) {
      this.gridApi = params.api;

      fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
        .then((resp) => resp.json())
        .then((data) => {
          this.rowData = data;
        });
    },
    toggleCaseSensitive(event: Event) {
      const caseSensitive = (event.target as HTMLInputElement).checked;
      this.findOptions = {
        ...this.findOptions,
        caseSensitive,
      };
    },
    toggleCurrentPageOnly(event: Event) {
      const currentPageOnly = (event.target as HTMLInputElement).checked;
      this.findOptions = {
        ...this.findOptions,
        currentPageOnly,
      };
    },
  },
  setup() {
    const pinnedTopRowData = ref<any[]>([{ athlete: "Top" }]);
    const pinnedBottomRowData = ref<any[]>([{ athlete: "Bottom" }]);
    const columnDefs = ref<ColDef[]>([
      { field: "athlete" },
      { field: "country" },
      { field: "sport", rowGroup: true, hide: true },
      { field: "year" },
      { field: "age", minWidth: 100 },
      { field: "gold", minWidth: 100 },
      { field: "silver", minWidth: 100 },
      { field: "bronze", minWidth: 100 },
    ]);
    const defaultColDef = ref<ColDef>({
      enableRowGroup: true,
    });
    const paginationPageSize = ref(5);
    const paginationPageSizeSelector = ref<number[] | boolean>([5, 10]);
    const rowData = ref<any[]>(null);

    return {
      pinnedTopRowData,
      pinnedBottomRowData,
      columnDefs,
      defaultColDef,
      paginationPageSize,
      paginationPageSizeSelector,
      rowData,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Customising Find](https://www.ag-grid.com/archive/36.2.0/examples/find/customising-find/vue3/)

## Find with Master / Detail

When using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/master-detail/), Find will not search within detail rows by default (either [Detail Grids](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/master-detail-grids/) or [Custom Details](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/master-detail-custom-detail/)). To enable Find to search within detail rows, set `searchDetail` within `findOptions` to `true`:

```ts
<ag-grid-vue
    :findOptions="findOptions"
    /* other grid options ... */>
</ag-grid-vue>

this.findOptions = {
    searchDetail: true,
};
```

### Detail Grids

If a row containing a Detail Grid is expanded, Find will automatically search within the Detail Grid. If the master row is not expanded, the grid does not exist yet, so Find does not know how many matches there are. Find cannot create all of the Detail Grids as there may be a very large number of them.

If you want Find to search within collapsed detail rows, then you must provide the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Detail Grid. If the active match moves to within the Detail Grid, the Detail Grid will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The following example demonstrates Find across nested Master / Detail Grids:

#### Find with Detail Grids

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  FindOptions,
  FirstDataRenderedEvent,
  GetDetailRowDataParams,
  GetFindMatchesParams,
  GetRowIdParams,
  IDetailCellRendererParams,
  ModuleRegistry,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

function getFindMatches(params: GetFindMatchesParams) {
  const getMatchesForValue = params.getMatchesForValue;
  let numMatches = 0;
  const checkRow = (row: any) => {
    for (const key of Object.keys(row)) {
      if (key === "children") {
        row.children.forEach((child: any) => checkRow(child));
      } else {
        numMatches += getMatchesForValue(row[key]);
      }
    }
  };
  params.data.children.forEach(checkRow);
  return numMatches;
}

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <ag-grid-vue
        style="width: 100%; height: 100%;"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"
        :masterDetail="true"
        :getRowId="getRowId"
        :detailCellRendererParams="detailCellRendererParams"
        :findOptions="findOptions"
        :toolbar="toolbar"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  data() {
    return {
      toolbar: {
        items: ["agFindToolbarItem"],
      },
    };
  },
  methods: {
    onFirstDataRendered(event: FirstDataRenderedEvent) {
      event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
    },
    getRowId(params: GetRowIdParams) {
      return params.data.a1;
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "a1", cellRenderer: "agGroupCellRenderer" },
      { field: "b1" },
    ]);
    const defaultColDef = ref<ColDef>({ flex: 1 });
    const rowData = ref<any[]>(getData());
    const findOptions = ref<FindOptions>({
      searchDetail: true,
    });
    const detailCellRendererParams = ref<Partial<IDetailCellRendererParams>>({
      // level 2 grid options
      detailGridOptions: {
        columnDefs: [
          { field: "a2", cellRenderer: "agGroupCellRenderer" },
          { field: "b2" },
        ],
        defaultColDef: {
          flex: 1,
        },
        masterDetail: true,
        detailRowHeight: 240,
        getRowId: (params: GetRowIdParams) => params.data.a2,
        findOptions: {
          searchDetail: true,
        },
        detailCellRendererParams: {
          // level 3 grid options
          detailGridOptions: {
            columnDefs: [
              { field: "a3", cellRenderer: "agGroupCellRenderer" },
              { field: "b3" },
            ],
            defaultColDef: {
              flex: 1,
            },
            getRowId: (params: GetRowIdParams) => params.data.a3,
          },
          getDetailRowData: (params: GetDetailRowDataParams) => {
            params.successCallback(params.data.children);
          },
          getFindMatches,
        } as IDetailCellRendererParams,
      },
      getDetailRowData: (params: GetDetailRowDataParams) => {
        params.successCallback(params.data.children);
      },
      getFindMatches,
    });

    return {
      columnDefs,
      defaultColDef,
      rowData,
      findOptions,
      detailCellRendererParams,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find with Detail Grids](https://www.ag-grid.com/archive/36.2.0/examples/find/find-detail-grid/vue3/)

### Custom Detail

For Find to work with Custom Detail Cells, Find needs to know how many matches are within the detail row. This is done by providing the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Custom Detail. If the active match moves to within the Custom Detail, the Custom Detail will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Custom Detail Cell Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find across Custom Details:

#### Find with Custom Details

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  type FindDetailCellRendererParams,
  FindOptions,
  FirstDataRenderedEvent,
  type GetFindMatchesParams,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import DetailCellRenderer from "./detailCellRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :rowData="rowData"
        :masterDetail="true"
        :detailCellRenderer="detailCellRenderer"
        :detailCellRendererParams="detailCellRendererParams"
        :detailRowHeight="100"
        :findOptions="findOptions"
        :toolbar="toolbar"
        @first-data-rendered="onFirstDataRendered"></ag-grid-vue>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    DetailCellRenderer,
  },
  data() {
    return {
      toolbar: {
        items: ["agFindToolbarItem"],
      },
    };
  },
  methods: {
    onFirstDataRendered(event: FirstDataRenderedEvent) {
      event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
    },
    onGridReady(params: GridReadyEvent) {
      fetch("https://www.ag-grid.com/example-assets/master-detail-data.json")
        .then((resp) => resp.json())
        .then((data) => {
          this.rowData = data;
        });
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      // group cell renderer needed for expand / collapse icons
      { field: "name", cellRenderer: "agGroupCellRenderer" },
      { field: "account" },
      { field: "calls" },
    ]);
    const rowData = ref<any[]>(null);
    const findOptions = ref<FindOptions>({
      searchDetail: true,
    });
    const detailCellRenderer = ref("DetailCellRenderer");
    const detailCellRendererParams = ref<FindDetailCellRendererParams>({
      getFindMatches: (params: GetFindMatchesParams) => {
        return params.getMatchesForValue("My Custom Detail");
      },
    });

    return {
      columnDefs,
      rowData,
      detailCellRenderer,
      detailCellRendererParams,
      findOptions,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find with Custom Details](https://www.ag-grid.com/archive/36.2.0/examples/find/find-custom-detail/vue3/)

## Find with Full Width Rows

For Find to work with [Full Width Rows](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/full-width-rows/), Find needs to know how many matches are within the row. This is done by providing the `getFindMatches` callback to the `fullWidthCellRendererParams` grid option. This tells Find how many matches are expected to be in the Full Width Row.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Full Width Row Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find with Full Width Rows:

#### Find with Full Width Rows

```ts
import { createApp, defineComponent, ref } from "vue";

import {
  ClientSideRowModelModule,
  ColDef,
  type FindFullWidthCellRendererParams,
  type GetFindMatchesParams,
  type IsFullWidthRowParams,
  ModuleRegistry,
  type RowHeightParams,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import { getData, getLatinText } from "./data";
import FullWidthCellRenderer from "./fullWidthCellRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

const VueExample = defineComponent({
  template: `
<div style="height: 100%">
    <ag-grid-vue
        style="width: 100%; height: 100%;"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :rowData="rowData"
        :getRowHeight="getRowHeight"
        :isFullWidthRow="isFullWidthRow"
        :fullWidthCellRenderer="fullWidthCellRenderer"
        :fullWidthCellRendererParams="fullWidthCellRendererParams"
        :toolbar="toolbar"></ag-grid-vue>
</div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    FullWidthCellRenderer,
  },
  data() {
    return {
      toolbar: {
        items: ["agFindToolbarItem"],
      },
    };
  },
  methods: {
    getRowHeight(params: RowHeightParams) {
      // return 100px height for full width rows
      if (this.isFullWidth(params.data)) {
        return 100;
      }
    },
    isFullWidthRow(params: IsFullWidthRowParams) {
      return this.isFullWidth(params.rowNode.data);
    },
    isFullWidth(data: any) {
      // return true when country is Peru, France or Italy
      return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
    },
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "name" },
      { field: "continent" },
      { field: "language" },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
    });
    const rowData = ref<any[]>(getData());
    const fullWidthCellRenderer = ref("FullWidthCellRenderer");
    const fullWidthCellRendererParams = ref<FindFullWidthCellRendererParams>({
      getFindMatches: (params: GetFindMatchesParams) => {
        const getMatchesForValue = params.getMatchesForValue;
        // this example only implements searching across part of the renderer
        let numMatches = getMatchesForValue("Sample Text in a Paragraph");
        getLatinText().forEach((paragraph) => {
          numMatches += getMatchesForValue(paragraph);
        });
        return numMatches;
      },
    });

    return {
      columnDefs,
      defaultColDef,
      rowData,
      fullWidthCellRenderer,
      fullWidthCellRendererParams,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Find with Full Width Rows](https://www.ag-grid.com/archive/36.2.0/examples/find/find-full-width/vue3/)

## Find with Custom Group Row Component

Using Find with a [Custom Group Row Inner Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-group-rows/#custom-inner-renderer) (`groupRowRendererParams.innerRenderer`) or a [Custom Group Row Component](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-group-rows/#custom-cell-renderer) (`groupRowRenderer`) is similar to using [Using Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/#using-find-with-cell-components). If the component displays text that does not appear in the cell value, the `getFindText` callback can be implemented on the `groupRowRendererParams` grid option. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```ts
<ag-grid-vue
    :groupRowRendererParams="groupRowRendererParams"
    /* other grid options ... */>
</ag-grid-vue>

this.groupRowRendererParams = {
    getFindText: params => `Group value is ${params.value}`,
};
```

## Content to Search

Find is designed to search within "visible" cell contents.

Searching is not performed within hidden columns. Columns not displayed due to [Column Groups](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/column-groups/) being expanded/collapsed are counted as being hidden.

The rows are searched after filtering and sorting have been performed.

Searching will be performed within the children of [Collapsed Row Groups](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/grouping-opening-groups/). When the active match is set to a child row within a collapsed group, the group is expanded (along with its parents if necessary).

When using [Row Pagination](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/row-pagination/), searching will be performed across all pages by default.

See the [Customising Find](https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/#customising-find) section for an example of using Find with Row Grouping, as well as how to customise behaviour for Pagination.

If data is mutated outside of the grid (e.g. not via grid options or API methods), Find will not re-run automatically. This would apply to situations where `api.refreshCells()` or `api.redrawRows()` are being used. To get Find to update, `api.findRefresh()` should be called after either of these API methods.


---
product: "AG Grid"
title: "Find"
description: "Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find ( + ) within the browser."
enterprise: true
framework: angular
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/view-refresh/"
    - title: "Reference Data"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/reference-data/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Find

Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find (`^ Ctrl` + `F`) within the browser.

> **Note**
>
> Find is only compatible with the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-models/).

## Enabling Find

### Using Quick Access Toolbar

The recommended way to display the Find input is as a [Quick Access Toolbar](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/toolbar/) item. This keeps the Find UI integrated with the grid and requires no additional markup.

#### Find with Toolbar

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [toolbar]="toolbar"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ];
  rowData!: any[];

  toolbar = {
    items: ["agFindToolbarItem" as const],
  };

  constructor(private http: HttpClient) {}

  onGridReady(params: GridReadyEvent) {
    this.http
      .get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Find with Toolbar](https://www.ag-grid.com/archive/36.2.0/examples/find/find-toolbar/angular/)

The configuration used in the example above is:

```ts
<ag-grid-angular
    [toolbar]="toolbar"
    /* other grid options ... */ />

this.toolbar = {
    items: ['agFindToolbarItem'],
};
```

### Using Grid Options

Find can also be enabled directly via the grid option `findSearchValue`, passing the text to search for.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findSearchValue` | `string` |  |  |  |

```ts
<ag-grid-angular
    [findSearchValue]="findSearchValue"
    /* other grid options ... */ />

this.findSearchValue = 'rowing';
```

The grid API methods `findNext()`, `findPrevious()`, and `findGoTo(matchNumber)` can be used to move between the matches, or `findClearActive()` can be used to clear the active match.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findNext` | `Function` |  |  |  |
| `findPrevious` | `Function` |  |  |  |
| `findGoTo` | `Function` |  |  |  |
| `findClearActive` | `Function` |  |  |  |

Changing the Find search value, changing the active match, or updates to the grid that cause changes to the visible cells (e.g. changing columns/rows) trigger the `findChanged` event. The event contains details on the active match, as well as the total number of matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findChanged` | `FindChangedEvent` |  |  |  |

The active match and the total number of matches can also be retrieved via the API.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetTotalMatches` | `Function` |  |  |  |
| `findGetActiveMatch` | `Function` |  |  |  |

#### Find

```ts
import { HttpClient } from "@angular/common/http";
import { Component, ElementRef, ViewChild } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FindChangedEvent,
  GridApi,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule } from "ag-grid-enterprise";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([FindModule, ClientSideRowModelModule]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div class="example-controls">
        <span>Find:</span>
        <input
          type="text"
          (input)="onInput($event)"
          (keydown)="onKeyDown($event)"
        />
        <button (click)="previous()">Previous</button>
        <button (click)="next()">Next</button>
        <span>{{ activeMatchNum }}</span>
      </div>
      <div class="example-controls">
        <span>Go to match:</span>
        <input #goToInput type="number" min="1" />
        <button (click)="goToFind()">Go To</button>
      </div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [rowData]="rowData"
      [findSearchValue]="findSearchValue"
      (findChanged)="onFindChanged($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  @ViewChild("goToInput", { read: ElementRef }) public goToInput!: ElementRef;

  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ];
  rowData!: any[];

  activeMatchNum: string = "";

  findSearchValue: string | undefined;

  constructor(private http: HttpClient) {}

  onFindChanged(event: FindChangedEvent) {
    const { activeMatch, totalMatches, findSearchValue } = event;
    this.activeMatchNum = findSearchValue?.length
      ? `${activeMatch?.numOverall ?? 0}/${totalMatches}`
      : "";
    console.log("findChanged", event);
  }

  next() {
    this.gridApi.findNext();
  }

  previous() {
    this.gridApi.findPrevious();
  }

  goToFind() {
    const num = Number(
      (this.goToInput.nativeElement as HTMLInputElement).value,
    );
    if (isNaN(num) || num < 0) {
      return;
    }
    this.gridApi.findGoTo(num);
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    this.http
      .get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }

  onInput(event: Event): void {
    this.findSearchValue = (event.target as HTMLInputElement).value;
  }

  onKeyDown(event: KeyboardEvent): void {
    if (event.key === "Enter") {
      event.preventDefault();
      const backwards = event.shiftKey;
      if (backwards) {
        this.previous();
      } else {
        this.next();
      }
    }
  }
}
```

[Live example: Find](https://www.ag-grid.com/archive/36.2.0/examples/find/find/angular/)

The Find input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/input-fields/).

## Using Find with Cell Components

By default, Find searches within the [Formatted Value](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/value-formatters/) of the cell, or the raw cell value if there is no Value Formatter. This is what is displayed in the cell by default.

[Cell Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/component-cell-renderer/) may display text that does not appear in the cell value. To enable Find to search within this additional text, the `getFindText` callback can be implemented on the Column Definition. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'year',
        getFindText: params => `Year is ${params.value}`,
    }
];
```

When providing a custom cell component, the component is responsible for highlighting any matches and active matches within the cell. The grid API provides the following methods to help with this.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetNumMatches` | `Function` |  |  |  |
| `findGetParts` | `Function` |  |  |  |

The following example demonstrates a custom cell component in the `Year` column that implements match highlighting using the methods above. The find input is provided by the toolbar. The custom cell component reuses the grid CSS classes `ag-find-match` and `ag-find-active-match` to apply the same styling as the default grid cell component.

#### Find with Cell Components

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FirstDataRenderedEvent,
  GetFindTextParams,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";

import { FindRenderer } from "./find-renderer.component";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, FindRenderer],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [findSearchValue]="findSearchValue"
    [toolbar]="toolbar"
    (gridReady)="onGridReady($event)"
    (firstDataRendered)="onFirstDataRendered($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    {
      field: "year",
      cellRenderer: FindRenderer,
      getFindText: (params: GetFindTextParams) => {
        const cellValue =
          params.getValueFormatted() ?? params.value?.toString();
        if (!cellValue?.length) {
          return null;
        }
        return `Year is ${cellValue}`;
      },
    },
  ];
  rowData!: any[];

  findSearchValue: string = "e";

  toolbar = {
    items: ["agFindToolbarItem" as const],
  };

  constructor(private http: HttpClient) {}

  onFirstDataRendered(event: FirstDataRenderedEvent) {
    event.api.findNext();
  }

  onGridReady(params: GridReadyEvent) {
    this.http
      .get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/examples/find/find-cell-components/angular/)

> **Note**
>
> Find does not work with the [Animate Show Changed Cell Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/change-cell-renderers/#animate-show-changed-cells) or the [Animate Slide Cell Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/change-cell-renderers/#animate-slide-cells). If using these, provide a `getFindText` that returns `null` to exclude them from the search results. The same approach should also be used if manually specifying `agCheckboxCellRenderer`.

## Customising Find

Find can be customised by providing an object of type `FindOptions` to the grid option `findOptions`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `currentPageOnly` | `boolean` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `searchDetail` | `boolean` |  |  |  |

```ts
<ag-grid-angular
    [findOptions]="findOptions"
    /* other grid options ... */ />

this.findOptions = {
    caseSensitive: true,
    currentPageOnly: true,
};
```

The following example demonstrates performing a case sensitive search, and finding matches within the current page only:

#### Customising Find

```ts
import { HttpClient } from "@angular/common/http";
import { Component, ElementRef, ViewChild } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FindChangedEvent,
  FindOptions,
  GridApi,
  GridReadyEvent,
  ModuleRegistry,
  PaginationModule,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  PaginationModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div class="example-header">
      <div class="example-controls">
        <label>
          <span>caseSensitive:</span>
          <input
            id="caseSensitive"
            type="checkbox"
            (change)="toggleCaseSensitive($event)"
            checked=""
          />
        </label>
        <label>
          <span>currentPageOnly:</span>
          <input
            id="currentPageOnly"
            type="checkbox"
            (change)="toggleCurrentPageOnly($event)"
            checked=""
          />
        </label>
      </div>
      <div class="example-controls">
        <span>Go to match:</span>
        <input #goToInput type="number" min="1" />
        <button (click)="goToFind()">Go To</button>
      </div>
      <div>{{ activeMatch }}</div>
    </div>
    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [pinnedTopRowData]="pinnedTopRowData"
      [pinnedBottomRowData]="pinnedBottomRowData"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [pagination]="true"
      [paginationPageSize]="paginationPageSize"
      [paginationPageSizeSelector]="paginationPageSizeSelector"
      [toolbar]="toolbar"
      [findOptions]="findOptions"
      [rowData]="rowData"
      (findChanged)="onFindChanged($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  @ViewChild("goToInput", { read: ElementRef }) public goToInput!: ElementRef;

  private gridApi!: GridApi;

  pinnedTopRowData: any[] = [{ athlete: "Top" }];
  pinnedBottomRowData: any[] = [{ athlete: "Bottom" }];
  columnDefs: ColDef[] = [
    { field: "athlete" },
    { field: "country" },
    { field: "sport", rowGroup: true, hide: true },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ];
  defaultColDef: ColDef = {
    enableRowGroup: true,
  };
  paginationPageSize = 5;
  paginationPageSizeSelector: number[] | boolean = [5, 10];
  rowData!: any[];

  activeMatch: string = "";

  toolbar = {
    items: [
      "agRowGroupPanelToolbarItem" as const,
      "agFindToolbarItem" as const,
    ],
  };
  findOptions: FindOptions = {
    caseSensitive: true,
    currentPageOnly: true,
  };

  constructor(private http: HttpClient) {}

  onFindChanged(event: FindChangedEvent) {
    const { activeMatch } = event;
    this.activeMatch = activeMatch
      ? `Active match: { pinned: ${activeMatch.node.rowPinned}, row index: ${activeMatch.node.rowIndex}, column: ${activeMatch.column?.getColId()}, match number in cell: ${activeMatch.numInMatch} }`
      : "";
  }

  goToFind() {
    const num = Number(
      (this.goToInput.nativeElement as HTMLInputElement).value,
    );
    if (isNaN(num) || num < 0) {
      return;
    }
    this.gridApi.findGoTo(num);
  }

  toggleCaseSensitive(event: Event) {
    const caseSensitive = (event.target as HTMLInputElement).checked;
    this.findOptions = {
      ...this.findOptions,
      caseSensitive,
    };
  }

  toggleCurrentPageOnly(event: Event) {
    const currentPageOnly = (event.target as HTMLInputElement).checked;
    this.findOptions = {
      ...this.findOptions,
      currentPageOnly,
    };
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;

    this.http
      .get<any[]>("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Customising Find](https://www.ag-grid.com/archive/36.2.0/examples/find/customising-find/angular/)

## Find with Master / Detail

When using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/master-detail/), Find will not search within detail rows by default (either [Detail Grids](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/master-detail-grids/) or [Custom Details](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/master-detail-custom-detail/)). To enable Find to search within detail rows, set `searchDetail` within `findOptions` to `true`:

```ts
<ag-grid-angular
    [findOptions]="findOptions"
    /* other grid options ... */ />

this.findOptions = {
    searchDetail: true,
};
```

### Detail Grids

If a row containing a Detail Grid is expanded, Find will automatically search within the Detail Grid. If the master row is not expanded, the grid does not exist yet, so Find does not know how many matches there are. Find cannot create all of the Detail Grids as there may be a very large number of them.

If you want Find to search within collapsed detail rows, then you must provide the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Detail Grid. If the active match moves to within the Detail Grid, the Detail Grid will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The following example demonstrates Find across nested Master / Detail Grids:

#### Find with Detail Grids

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FindOptions,
  FirstDataRenderedEvent,
  GetDetailRowDataParams,
  GetFindMatchesParams,
  GetRowIdParams,
  IDetailCellRendererParams,
  ModuleRegistry,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [masterDetail]="true"
    [getRowId]="getRowId"
    [detailCellRendererParams]="detailCellRendererParams"
    [findOptions]="findOptions"
    [toolbar]="toolbar"
    (firstDataRendered)="onFirstDataRendered($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "a1", cellRenderer: "agGroupCellRenderer" },
    { field: "b1" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData = getData();
  getRowId = (params: GetRowIdParams) => params.data.a1;
  findOptions: FindOptions = {
    searchDetail: true,
  };
  toolbar = {
    items: ["agFindToolbarItem" as const],
  };
  detailCellRendererParams: Partial<IDetailCellRendererParams> = {
    // level 2 grid options
    detailGridOptions: {
      columnDefs: [
        { field: "a2", cellRenderer: "agGroupCellRenderer" },
        { field: "b2" },
      ],
      defaultColDef: {
        flex: 1,
      },
      masterDetail: true,
      detailRowHeight: 240,
      getRowId: (params: GetRowIdParams) => params.data.a2,
      findOptions: {
        searchDetail: true,
      },
      detailCellRendererParams: {
        // level 3 grid options
        detailGridOptions: {
          columnDefs: [
            { field: "a3", cellRenderer: "agGroupCellRenderer" },
            { field: "b3" },
          ],
          defaultColDef: {
            flex: 1,
          },
          getRowId: (params: GetRowIdParams) => params.data.a3,
        },
        getDetailRowData: (params: GetDetailRowDataParams) => {
          params.successCallback(params.data.children);
        },
        getFindMatches: (params: GetFindMatchesParams) =>
          this.getFindMatches(params),
      } as IDetailCellRendererParams,
    },
    getDetailRowData: (params: GetDetailRowDataParams) => {
      params.successCallback(params.data.children);
    },
    getFindMatches: (params: GetFindMatchesParams) =>
      this.getFindMatches(params),
  };

  onFirstDataRendered(event: FirstDataRenderedEvent) {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  }

  private getFindMatches(params: GetFindMatchesParams) {
    const getMatchesForValue = params.getMatchesForValue;
    let numMatches = 0;
    const checkRow = (row: any) => {
      for (const key of Object.keys(row)) {
        if (key === "children") {
          row.children.forEach((child: any) => checkRow(child));
        } else {
          numMatches += getMatchesForValue(row[key]);
        }
      }
    };
    params.data.children.forEach(checkRow);
    return numMatches;
  }
}
```

[Live example: Find with Detail Grids](https://www.ag-grid.com/archive/36.2.0/examples/find/find-detail-grid/angular/)

### Custom Detail

For Find to work with Custom Detail Cells, Find needs to know how many matches are within the detail row. This is done by providing the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Custom Detail. If the active match moves to within the Custom Detail, the Custom Detail will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Custom Detail Cell Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find across Custom Details:

#### Find with Custom Details

```ts
import { HttpClient } from "@angular/common/http";
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FindDetailCellRendererParams,
  FindOptions,
  FirstDataRenderedEvent,
  GetFindMatchesParams,
  GridReadyEvent,
  ModuleRegistry,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";

import { DetailCellRenderer } from "./detail-cell-renderer.component";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [rowData]="rowData"
    [masterDetail]="true"
    [detailCellRenderer]="detailCellRenderer"
    [detailCellRendererParams]="detailCellRendererParams"
    [detailRowHeight]="100"
    [findOptions]="findOptions"
    [toolbar]="toolbar"
    (firstDataRendered)="onFirstDataRendered($event)"
    (gridReady)="onGridReady($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    // group cell renderer needed for expand / collapse icons
    { field: "name", cellRenderer: "agGroupCellRenderer" },
    { field: "account" },
    { field: "calls" },
  ];
  rowData!: any[];

  detailCellRenderer = DetailCellRenderer;

  detailCellRendererParams: FindDetailCellRendererParams = {
    getFindMatches: (params: GetFindMatchesParams) => {
      return params.getMatchesForValue("My Custom Detail");
    },
  };

  toolbar = {
    items: ["agFindToolbarItem" as const],
  };

  findOptions: FindOptions = {
    searchDetail: true,
  };

  constructor(private http: HttpClient) {}

  onFirstDataRendered(event: FirstDataRenderedEvent) {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  }

  onGridReady(params: GridReadyEvent) {
    this.http
      .get<
        any[]
      >("https://www.ag-grid.com/example-assets/master-detail-data.json")
      .subscribe((data) => (this.rowData = data));
  }
}
```

[Live example: Find with Custom Details](https://www.ag-grid.com/archive/36.2.0/examples/find/find-custom-detail/angular/)

## Find with Full Width Rows

For Find to work with [Full Width Rows](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/full-width-rows/), Find needs to know how many matches are within the row. This is done by providing the `getFindMatches` callback to the `fullWidthCellRendererParams` grid option. This tells Find how many matches are expected to be in the Full Width Row.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Full Width Row Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find with Full Width Rows:

#### Find with Full Width Rows

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import {
  ClientSideRowModelModule,
  ColDef,
  FindFullWidthCellRendererParams,
  GetFindMatchesParams,
  IsFullWidthRowParams,
  ModuleRegistry,
  RowHeightParams,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";

import { getData, getLatinText } from "./data";
import { FullWidthCellRenderer } from "./full-width-cell-renderer.component";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    [getRowHeight]="getRowHeight"
    [isFullWidthRow]="isFullWidthRow"
    [fullWidthCellRenderer]="fullWidthCellRenderer"
    [fullWidthCellRendererParams]="fullWidthCellRendererParams"
    [toolbar]="toolbar"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    { field: "name" },
    { field: "continent" },
    { field: "language" },
  ];
  defaultColDef: ColDef = {
    flex: 1,
  };
  rowData = getData();
  getRowHeight = (params: RowHeightParams) => {
    // return 100px height for full width rows
    if (this.isFullWidth(params.data)) {
      return 100;
    }
  };
  isFullWidthRow = (params: IsFullWidthRowParams) => {
    return this.isFullWidth(params.rowNode.data);
  };
  fullWidthCellRenderer = FullWidthCellRenderer;
  fullWidthCellRendererParams: FindFullWidthCellRendererParams = {
    getFindMatches: (params: GetFindMatchesParams) => {
      const getMatchesForValue = params.getMatchesForValue;
      // this example only implements searching across part of the renderer
      let numMatches = getMatchesForValue("Sample Text in a Paragraph");
      getLatinText().forEach((paragraph) => {
        numMatches += getMatchesForValue(paragraph);
      });
      return numMatches;
    },
  };

  toolbar = {
    items: ["agFindToolbarItem" as const],
  };

  private isFullWidth(data: any) {
    // return true when country is Peru, France or Italy
    return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
  }
}
```

[Live example: Find with Full Width Rows](https://www.ag-grid.com/archive/36.2.0/examples/find/find-full-width/angular/)

## Find with Custom Group Row Component

Using Find with a [Custom Group Row Inner Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-group-rows/#custom-inner-renderer) (`groupRowRendererParams.innerRenderer`) or a [Custom Group Row Component](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-group-rows/#custom-cell-renderer) (`groupRowRenderer`) is similar to using [Using Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/#using-find-with-cell-components). If the component displays text that does not appear in the cell value, the `getFindText` callback can be implemented on the `groupRowRendererParams` grid option. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```ts
<ag-grid-angular
    [groupRowRendererParams]="groupRowRendererParams"
    /* other grid options ... */ />

this.groupRowRendererParams = {
    getFindText: params => `Group value is ${params.value}`,
};
```

## Content to Search

Find is designed to search within "visible" cell contents.

Searching is not performed within hidden columns. Columns not displayed due to [Column Groups](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/column-groups/) being expanded/collapsed are counted as being hidden.

The rows are searched after filtering and sorting have been performed.

Searching will be performed within the children of [Collapsed Row Groups](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/grouping-opening-groups/). When the active match is set to a child row within a collapsed group, the group is expanded (along with its parents if necessary).

When using [Row Pagination](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/row-pagination/), searching will be performed across all pages by default.

See the [Customising Find](https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/#customising-find) section for an example of using Find with Row Grouping, as well as how to customise behaviour for Pagination.

If data is mutated outside of the grid (e.g. not via grid options or API methods), Find will not re-run automatically. This would apply to situations where `api.refreshCells()` or `api.redrawRows()` are being used. To get Find to update, `api.findRefresh()` should be called after either of these API methods.


---
product: "AG Grid"
title: "Find"
description: "Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find ( + ) within the browser."
enterprise: true
framework: react
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-content/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/view-refresh/"
    - title: "Reference Data"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/reference-data/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Find

Find allows for values to be searched within the grid, with all matches highlighted and navigable, similar to find (`^ Ctrl` + `F`) within the browser.

> **Note**
>
> Find is only compatible with the [Client-Side Row Model](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-models/).

## Enabling Find

### Using Quick Access Toolbar

The recommended way to display the Find input is as a [Quick Access Toolbar](https://www.ag-grid.com/archive/36.2.0/react-data-grid/toolbar/) item. This keeps the Find UI integrated with the grid and requires no additional markup.

#### Find with Toolbar

```tsx
"use client";

import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type { ColDef, GridReadyEvent } from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [FindModule, ToolbarModule, ClientSideRowModelModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const [columnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ]);

  const toolbar = useMemo(
    () => ({
      items: ["agFindToolbarItem" as const],
    }),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setRowData(data));
  }, []);

  return (
    <div style={containerStyle}>
      <div style={gridStyle}>
        <AgGridReact
          rowData={rowData}
          columnDefs={columnDefs}
          modules={modules}
          toolbar={toolbar}
          onGridReady={onGridReady}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find with Toolbar](https://www.ag-grid.com/archive/36.2.0/examples/find/find-toolbar/reactFunctionalTs/)

The configuration used in the example above is:

```jsx
const toolbar = {
    items: ['agFindToolbarItem'],
};

<AgGridReact toolbar={toolbar} />
```

### Using Grid Options

Find can also be enabled directly via the grid option `findSearchValue`, passing the text to search for.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findSearchValue` | `string` |  |  |  |

```jsx
const findSearchValue = 'rowing';

<AgGridReact findSearchValue={findSearchValue} />
```

The grid API methods `findNext()`, `findPrevious()`, and `findGoTo(matchNumber)` can be used to move between the matches, or `findClearActive()` can be used to clear the active match.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findNext` | `Function` |  |  |  |
| `findPrevious` | `Function` |  |  |  |
| `findGoTo` | `Function` |  |  |  |
| `findClearActive` | `Function` |  |  |  |

Changing the Find search value, changing the active match, or updates to the grid that cause changes to the visible cells (e.g. changing columns/rows) trigger the `findChanged` event. The event contains details on the active match, as well as the total number of matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findChanged` | `FindChangedEvent` |  |  |  |

The active match and the total number of matches can also be retrieved via the API.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetTotalMatches` | `Function` |  |  |  |
| `findGetActiveMatch` | `Function` |  |  |  |

#### Find

```tsx
"use client";

import React, {
  type ChangeEvent,
  type KeyboardEvent,
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import {
  ClientSideRowModelModule,
  ColDef,
  FindChangedEvent,
  GridReadyEvent,
  ModuleRegistry,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule } from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([FindModule, ClientSideRowModelModule]);

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "sport" },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ]);

  const goToRef = useRef<HTMLInputElement>(null);

  const [findSearchValue, setFindSearchValue] = useState<string>();

  const [activeMatchNum, setActiveMatchNum] = useState<string>();

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setRowData(data));
  }, []);

  const onFindChanged = useCallback((event: FindChangedEvent) => {
    const { activeMatch, totalMatches, findSearchValue } = event;
    setActiveMatchNum(
      findSearchValue?.length
        ? `${activeMatch?.numOverall ?? 0}/${totalMatches}`
        : "",
    );
    console.log("findChanged", event);
  }, []);

  const onInput = useCallback((event: ChangeEvent<HTMLInputElement>) => {
    setFindSearchValue(event.target.value);
  }, []);

  const onKeyDown = useCallback((event: KeyboardEvent) => {
    if (event.key === "Enter") {
      event.preventDefault();
      const backwards = event.shiftKey;
      if (backwards) {
        previous();
      } else {
        next();
      }
    }
  }, []);

  const next = useCallback(() => {
    gridRef.current!.api.findNext();
  }, []);

  const previous = useCallback(() => {
    gridRef.current!.api.findPrevious();
  }, []);

  const goToFind = useCallback(() => {
    const num = Number(goToRef.current?.value);
    if (isNaN(num) || num < 0) {
      return;
    }
    gridRef.current!.api.findGoTo(num);
  }, []);

  return (
    <div style={containerStyle}>
      <div className="example-wrapper">
        <div className="example-header">
          <div className="example-controls">
            <span>Find:</span>
            <input type="text" onInput={onInput} onKeyDown={onKeyDown} />
            <button onClick={previous}>Previous</button>
            <button onClick={next}>Next</button>
            <span>{activeMatchNum}</span>
          </div>
          <div className="example-controls">
            <span>Go to match:</span>
            <input type="number" min="1" ref={goToRef} />
            <button onClick={goToFind}>Go To</button>
          </div>
        </div>

        <div style={gridStyle}>
          <AgGridReact
            ref={gridRef}
            rowData={rowData}
            columnDefs={columnDefs}
            findSearchValue={findSearchValue}
            onGridReady={onGridReady}
            onFindChanged={onFindChanged}
          />
        </div>
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find](https://www.ag-grid.com/archive/36.2.0/examples/find/find/reactFunctionalTs/)

The Find input shares the grid-wide input behaviour (clear button, browser autocomplete) described in [Input Fields](https://www.ag-grid.com/archive/36.2.0/react-data-grid/input-fields/).

## Using Find with Cell Components

By default, Find searches within the [Formatted Value](https://www.ag-grid.com/archive/36.2.0/react-data-grid/value-formatters/) of the cell, or the raw cell value if there is no Value Formatter. This is what is displayed in the cell by default.

[Cell Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/component-cell-renderer/) may display text that does not appear in the cell value. To enable Find to search within this additional text, the `getFindText` callback can be implemented on the Column Definition. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'year',
        getFindText: params => `Year is ${params.value}`,
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

When providing a custom cell component, the component is responsible for highlighting any matches and active matches within the cell. The grid API provides the following methods to help with this.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `findGetNumMatches` | `Function` |  |  |  |
| `findGetParts` | `Function` |  |  |  |

The following example demonstrates a custom cell component in the `Year` column that implements match highlighting using the methods above. The find input is provided by the toolbar. The custom cell component reuses the grid CSS classes `ag-find-match` and `ag-find-active-match` to apply the same styling as the default grid cell component.

#### Find with Cell Components

```tsx
"use client";

import React, {
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FirstDataRenderedEvent,
  GetFindTextParams,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import FindRenderer from "./findRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [FindModule, ToolbarModule, ClientSideRowModelModule];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const [columnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    {
      field: "year",
      cellRenderer: FindRenderer,
      getFindText: (params: GetFindTextParams) => {
        const cellValue =
          params.getValueFormatted() ?? params.value?.toString();
        if (!cellValue?.length) {
          return null;
        }
        return `Year is ${cellValue}`;
      },
    },
  ]);

  const toolbar = useMemo(
    () => ({ items: ["agFindToolbarItem" as const] }),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setRowData(data));
  }, []);

  const onFirstDataRendered = useCallback((event: FirstDataRenderedEvent) => {
    event.api.findNext();
  }, []);

  return (
    <div style={containerStyle}>
      <div style={gridStyle}>
        <AgGridReact
          ref={gridRef}
          rowData={rowData}
          columnDefs={columnDefs}
          modules={modules}
          findSearchValue="e"
          toolbar={toolbar}
          onGridReady={onGridReady}
          onFirstDataRendered={onFirstDataRendered}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/examples/find/find-cell-components/reactFunctionalTs/)

> **Note**
>
> Find does not work with the [Animate Show Changed Cell Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/change-cell-renderers/#animate-show-changed-cells) or the [Animate Slide Cell Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/change-cell-renderers/#animate-slide-cells). If using these, provide a `getFindText` that returns `null` to exclude them from the search results. The same approach should also be used if manually specifying `agCheckboxCellRenderer`.

## Customising Find

Find can be customised by providing an object of type `FindOptions` to the grid option `findOptions`.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `currentPageOnly` | `boolean` |  |  |  |
| `caseSensitive` | `boolean` |  |  |  |
| `searchDetail` | `boolean` |  |  |  |

```jsx
const findOptions = {
    caseSensitive: true,
    currentPageOnly: true,
};

<AgGridReact findOptions={findOptions} />
```

The following example demonstrates performing a case sensitive search, and finding matches within the current page only:

#### Customising Find

```tsx
"use client";

import React, {
  ChangeEvent,
  StrictMode,
  useCallback,
  useMemo,
  useRef,
  useState,
} from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FindChangedEvent,
  FindOptions,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  PaginationModule,
  PinnedRowModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  FindModule,
  ToolbarModule,
  RowGroupingModule,
  RowGroupingPanelModule,
  PinnedRowModule,
  ClientSideRowModelModule,
  PaginationModule,
];

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const pinnedTopRowData = useMemo<any[]>(() => {
    return [{ athlete: "Top" }];
  }, []);
  const pinnedBottomRowData = useMemo<any[]>(() => {
    return [{ athlete: "Bottom" }];
  }, []);
  const [columnDefs] = useState<ColDef[]>([
    { field: "athlete" },
    { field: "country" },
    { field: "sport", rowGroup: true, hide: true },
    { field: "year" },
    { field: "age", minWidth: 100 },
    { field: "gold", minWidth: 100 },
    { field: "silver", minWidth: 100 },
    { field: "bronze", minWidth: 100 },
  ]);

  const defaultColDef = useMemo<ColDef>(() => {
    return {
      enableRowGroup: true,
    };
  }, []);
  const paginationPageSizeSelector = useMemo<number[] | boolean>(() => {
    return [5, 10];
  }, []);
  const [findOptions, setFindOptions] = useState<FindOptions>({
    caseSensitive: true,
    currentPageOnly: true,
  });

  const toolbar = useMemo(
    () => ({
      items: [
        "agRowGroupPanelToolbarItem" as const,
        "agFindToolbarItem" as const,
      ],
    }),
    [],
  );

  const goToRef = useRef<HTMLInputElement>(null);

  const [activeMatch, setActiveMatch] = useState<string>();

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setRowData(data));
  }, []);

  const onFindChanged = useCallback((event: FindChangedEvent) => {
    const { activeMatch } = event;
    setActiveMatch(
      activeMatch
        ? `Active match: { pinned: ${activeMatch.node.rowPinned}, row index: ${activeMatch.node.rowIndex}, column: ${activeMatch.column?.getColId()}, match number in cell: ${activeMatch.numInMatch} }`
        : "",
    );
  }, []);

  const goToFind = useCallback(() => {
    const num = Number(goToRef.current?.value);
    if (isNaN(num) || num < 0) {
      return;
    }
    gridRef.current!.api.findGoTo(num);
  }, []);

  const toggleCaseSensitive = useCallback(
    (event: ChangeEvent<HTMLInputElement>) => {
      const caseSensitive = event.target.checked;
      setFindOptions((oldFindOptions) => ({
        ...oldFindOptions,
        caseSensitive,
      }));
    },
    [],
  );

  const toggleCurrentPageOnly = useCallback(
    (event: ChangeEvent<HTMLInputElement>) => {
      const currentPageOnly = event.target.checked;
      setFindOptions((oldFindOptions) => ({
        ...oldFindOptions,
        currentPageOnly,
      }));
    },
    [],
  );

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            <div className="example-controls">
              <label>
                <span>caseSensitive:</span>
                <input
                  id="caseSensitive"
                  type="checkbox"
                  onChange={toggleCaseSensitive}
                  checked={findOptions.caseSensitive}
                />
              </label>
              <label>
                <span>currentPageOnly:</span>
                <input
                  id="currentPageOnly"
                  type="checkbox"
                  onChange={toggleCurrentPageOnly}
                  checked={findOptions.currentPageOnly}
                />
              </label>
            </div>
            <div className="example-controls">
              <span>Go to match:</span>
              <input type="number" min="1" ref={goToRef} />
              <button onClick={goToFind}>Go To</button>
            </div>
            <div>{activeMatch}</div>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              pinnedTopRowData={pinnedTopRowData}
              pinnedBottomRowData={pinnedBottomRowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              pagination={true}
              paginationPageSize={5}
              paginationPageSizeSelector={paginationPageSizeSelector}
              toolbar={toolbar}
              findOptions={findOptions}
              onGridReady={onGridReady}
              onFindChanged={onFindChanged}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Customising Find](https://www.ag-grid.com/archive/36.2.0/examples/find/customising-find/reactFunctionalTs/)

## Find with Master / Detail

When using [Master / Detail](https://www.ag-grid.com/archive/36.2.0/react-data-grid/master-detail/), Find will not search within detail rows by default (either [Detail Grids](https://www.ag-grid.com/archive/36.2.0/react-data-grid/master-detail-grids/) or [Custom Details](https://www.ag-grid.com/archive/36.2.0/react-data-grid/master-detail-custom-detail/)). To enable Find to search within detail rows, set `searchDetail` within `findOptions` to `true`:

```jsx
const findOptions = {
    searchDetail: true,
};

<AgGridReact findOptions={findOptions} />
```

### Detail Grids

If a row containing a Detail Grid is expanded, Find will automatically search within the Detail Grid. If the master row is not expanded, the grid does not exist yet, so Find does not know how many matches there are. Find cannot create all of the Detail Grids as there may be a very large number of them.

If you want Find to search within collapsed detail rows, then you must provide the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Detail Grid. If the active match moves to within the Detail Grid, the Detail Grid will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The following example demonstrates Find across nested Master / Detail Grids:

#### Find with Detail Grids

```tsx
"use client";

import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FindOptions,
  FirstDataRenderedEvent,
  GetDetailRowDataParams,
  GetFindMatchesParams,
  GetRowIdParams,
  IDetailCellRendererParams,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import { getData } from "./data";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData] = useState<any[]>(getData());
  const [columnDefs] = useState<ColDef[]>([
    { field: "a1", cellRenderer: "agGroupCellRenderer" },
    { field: "b1" },
  ]);
  const defaultColDef = useMemo<ColDef>(
    () => ({
      flex: 1,
    }),
    [],
  );

  const getRowId = useCallback((params: GetRowIdParams) => params.data.a1, []);

  const getFindMatches = useCallback((params: GetFindMatchesParams) => {
    const getMatchesForValue = params.getMatchesForValue;
    let numMatches = 0;
    const checkRow = (row: any) => {
      for (const key of Object.keys(row)) {
        if (key === "children") {
          row.children.forEach((child: any) => checkRow(child));
        } else {
          numMatches += getMatchesForValue(row[key]);
        }
      }
    };
    params.data.children.forEach(checkRow);
    return numMatches;
  }, []);

  const detailCellRendererParams = useMemo<Partial<IDetailCellRendererParams>>(
    () => ({
      // level 2 grid options
      detailGridOptions: {
        columnDefs: [
          { field: "a2", cellRenderer: "agGroupCellRenderer" },
          { field: "b2" },
        ],
        defaultColDef: {
          flex: 1,
        },
        masterDetail: true,
        detailRowHeight: 240,
        getRowId: (params: GetRowIdParams) => params.data.a2,
        findOptions: {
          searchDetail: true,
        },
        detailCellRendererParams: {
          // level 3 grid options
          detailGridOptions: {
            columnDefs: [
              { field: "a3", cellRenderer: "agGroupCellRenderer" },
              { field: "b3" },
            ],
            defaultColDef: {
              flex: 1,
            },
            getRowId: (params: GetRowIdParams) => params.data.a3,
          },
          getDetailRowData: (params: GetDetailRowDataParams) => {
            params.successCallback(params.data.children);
          },
          getFindMatches,
        } as IDetailCellRendererParams,
      },
      getDetailRowData: (params: GetDetailRowDataParams) => {
        params.successCallback(params.data.children);
      },
      getFindMatches,
    }),
    [],
  );

  const findOptions = useMemo<FindOptions>(
    () => ({
      searchDetail: true,
    }),
    [],
  );

  const toolbar = useMemo(
    () => ({ items: ["agFindToolbarItem" as const] }),
    [],
  );

  const onFirstDataRendered = useCallback((event: FirstDataRenderedEvent) => {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  }, []);

  return (
    <div style={containerStyle}>
      <div style={gridStyle}>
        <AgGridReact
          rowData={rowData}
          columnDefs={columnDefs}
          defaultColDef={defaultColDef}
          masterDetail
          getRowId={getRowId}
          detailCellRendererParams={detailCellRendererParams}
          findOptions={findOptions}
          toolbar={toolbar}
          modules={modules}
          onFirstDataRendered={onFirstDataRendered}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find with Detail Grids](https://www.ag-grid.com/archive/36.2.0/examples/find/find-detail-grid/reactFunctionalTs/)

### Custom Detail

For Find to work with Custom Detail Cells, Find needs to know how many matches are within the detail row. This is done by providing the `getFindMatches` callback to the `detailCellRendererParams` grid option. This tells Find how many matches are expected to be in the Custom Detail. If the active match moves to within the Custom Detail, the Custom Detail will automatically be expanded.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Custom Detail Cell Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find across Custom Details:

#### Find with Custom Details

```tsx
"use client";

import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FindDetailCellRendererParams,
  FindOptions,
  FirstDataRenderedEvent,
  GetFindMatchesParams,
  GridReadyEvent,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  RowApiModule,
  enableDevValidations,
} from "ag-grid-community";
import {
  FindModule,
  MasterDetailModule,
  ToolbarModule,
} from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import DetailCellRenderer from "./detailCellRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  FindModule,
  ToolbarModule,
  ClientSideRowModelModule,
  MasterDetailModule,
  RowApiModule,
];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>();
  const [columnDefs] = useState<ColDef[]>([
    // group cell renderer needed for expand / collapse icons
    { field: "name", cellRenderer: "agGroupCellRenderer" },
    { field: "account" },
    { field: "calls" },
  ]);

  const detailCellRenderer = useMemo(() => DetailCellRenderer, []);

  const detailCellRendererParams = useMemo<FindDetailCellRendererParams>(
    () => ({
      getFindMatches: (params: GetFindMatchesParams) => {
        return params.getMatchesForValue("My Custom Detail");
      },
    }),
    [],
  );

  const findOptions = useMemo<FindOptions>(
    () => ({
      searchDetail: true,
    }),
    [],
  );

  const toolbar = useMemo(
    () => ({ items: ["agFindToolbarItem" as const] }),
    [],
  );

  const onGridReady = useCallback((params: GridReadyEvent) => {
    fetch("https://www.ag-grid.com/example-assets/master-detail-data.json")
      .then((resp) => resp.json())
      .then((data: any[]) => setRowData(data));
  }, []);

  const onFirstDataRendered = useCallback((event: FirstDataRenderedEvent) => {
    event.api.getDisplayedRowAtIndex(0)?.setExpanded(true);
  }, []);

  return (
    <div style={containerStyle}>
      <div style={gridStyle}>
        <AgGridReact
          rowData={rowData}
          columnDefs={columnDefs}
          masterDetail
          detailCellRenderer={detailCellRenderer}
          detailCellRendererParams={detailCellRendererParams}
          detailRowHeight={100}
          findOptions={findOptions}
          toolbar={toolbar}
          modules={modules}
          onGridReady={onGridReady}
          onFirstDataRendered={onFirstDataRendered}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find with Custom Details](https://www.ag-grid.com/archive/36.2.0/examples/find/find-custom-detail/reactFunctionalTs/)

## Find with Full Width Rows

For Find to work with [Full Width Rows](https://www.ag-grid.com/archive/36.2.0/react-data-grid/full-width-rows/), Find needs to know how many matches are within the row. This is done by providing the `getFindMatches` callback to the `fullWidthCellRendererParams` grid option. This tells Find how many matches are expected to be in the Full Width Row.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindMatches` | `GetFindMatches` |  |  |  |

The Full Width Row Component is responsible for highlighting matches, similar to [Custom Cell Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/#using-find-with-cell-components).

The following example demonstrates Find with Full Width Rows:

#### Find with Full Width Rows

```tsx
"use client";

import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  FindFullWidthCellRendererParams,
  GetFindMatchesParams,
  IsFullWidthRowParams,
  RowHeightParams,
} from "ag-grid-community";
import {
  ClientSideRowModelModule,
  enableDevValidations,
} from "ag-grid-community";
import { FindModule, ToolbarModule } from "ag-grid-enterprise";
import { AgGridReact } from "ag-grid-react";

import { getData, getLatinText } from "./data";
import FullWidthCellRenderer from "./fullWidthCellRenderer";
import "./styles.css";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [FindModule, ToolbarModule, ClientSideRowModelModule];

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData] = useState<any[]>(getData());
  const [columnDefs] = useState<ColDef[]>([
    { field: "name" },
    { field: "continent" },
    { field: "language" },
  ]);
  const defaultColDef = useMemo<ColDef>(
    () => ({
      flex: 1,
    }),
    [],
  );

  const isFullWidth = useCallback((data: any) => {
    // return true when country is Peru, France or Italy
    return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
  }, []);

  const getRowHeight = useCallback((params: RowHeightParams) => {
    // return 100px height for full width rows
    if (isFullWidth(params.data)) {
      return 100;
    }
  }, []);

  const isFullWidthRow = useCallback((params: IsFullWidthRowParams) => {
    return isFullWidth(params.rowNode.data);
  }, []);

  const fullWidthCellRenderer = useMemo(() => FullWidthCellRenderer, []);

  const fullWidthCellRendererParams = useMemo<FindFullWidthCellRendererParams>(
    () => ({
      getFindMatches: (params: GetFindMatchesParams) => {
        const getMatchesForValue = params.getMatchesForValue;
        // this example only implements searching across part of the renderer
        let numMatches = getMatchesForValue("Sample Text in a Paragraph");
        getLatinText().forEach((paragraph) => {
          numMatches += getMatchesForValue(paragraph);
        });
        return numMatches;
      },
    }),
    [],
  );

  const toolbar = useMemo(
    () => ({ items: ["agFindToolbarItem" as const] }),
    [],
  );

  return (
    <div style={containerStyle}>
      <div style={gridStyle}>
        <AgGridReact
          rowData={rowData}
          columnDefs={columnDefs}
          defaultColDef={defaultColDef}
          getRowHeight={getRowHeight}
          isFullWidthRow={isFullWidthRow}
          fullWidthCellRenderer={fullWidthCellRenderer}
          fullWidthCellRendererParams={fullWidthCellRendererParams}
          toolbar={toolbar}
          modules={modules}
        />
      </div>
    </div>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Find with Full Width Rows](https://www.ag-grid.com/archive/36.2.0/examples/find/find-full-width/reactFunctionalTs/)

## Find with Custom Group Row Component

Using Find with a [Custom Group Row Inner Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-group-rows/#custom-inner-renderer) (`groupRowRendererParams.innerRenderer`) or a [Custom Group Row Component](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-group-rows/#custom-cell-renderer) (`groupRowRenderer`) is similar to using [Using Find with Cell Components](https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/#using-find-with-cell-components). If the component displays text that does not appear in the cell value, the `getFindText` callback can be implemented on the `groupRowRendererParams` grid option. Find will search within this value for matches.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `getFindText` | `GetFindTextFunc` |  |  |  |

```jsx
const groupRowRendererParams = {
    getFindText: params => `Group value is ${params.value}`,
};

<AgGridReact groupRowRendererParams={groupRowRendererParams} />
```

## Content to Search

Find is designed to search within "visible" cell contents.

Searching is not performed within hidden columns. Columns not displayed due to [Column Groups](https://www.ag-grid.com/archive/36.2.0/react-data-grid/column-groups/) being expanded/collapsed are counted as being hidden.

The rows are searched after filtering and sorting have been performed.

Searching will be performed within the children of [Collapsed Row Groups](https://www.ag-grid.com/archive/36.2.0/react-data-grid/grouping-opening-groups/). When the active match is set to a child row within a collapsed group, the group is expanded (along with its parents if necessary).

When using [Row Pagination](https://www.ag-grid.com/archive/36.2.0/react-data-grid/row-pagination/), searching will be performed across all pages by default.

See the [Customising Find](https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/#customising-find) section for an example of using Find with Row Grouping, as well as how to customise behaviour for Pagination.

If data is mutated outside of the grid (e.g. not via grid options or API methods), Find will not re-run automatically. This would apply to situations where `api.refreshCells()` or `api.redrawRows()` are being used. To get Find to update, `api.findRefresh()` should be called after either of these API methods.
